#pragma once


namespace Simulator {

	using namespace System;

	public ref class LCD 
	{
	public:
		LCD();
		String^ LCDText() { return m_displayOn ? (m_lcdText->Substring(0,16) + "\r\n" +  m_lcdText->Substring(16,16)) : "                                                "; }
		void ClearLCD() { m_lcdText = "                                                "; }
		void Write(unsigned long port, unsigned char value);
              void WriteNibble(unsigned long port, unsigned char value);

	protected:
		~LCD() {}

		String^ m_lcdText;
		int m_lcdPos;
              bool m_ddramActive;
              bool m_displayOn;
              bool m_4bitMode;
              int m_4bitPhase;
              unsigned char m_4bitNibble;
	};
}

